/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package contents;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import de.trantor.mail.Message;
import de.trantor.mail.Envelope;
import util.Datas;
import mmc.StartMidlet;
import threads.SmtpThread;
import java.util.Vector;

/**
 * Screen for writing mails
 * @author Gabriele Bianchi
 *
 */
public class ComposeScreen extends Form implements CommandListener{

    public TextBox text = null; 
	public TextField rec_address = new TextField("Recipients:", "Use \",\" to separate recipients addresses", 128, TextField.ANY);
    public TextField subject = new TextField("Subject:", "", 128, TextField.ANY);
    public TextField cc = new TextField("Cc:", "", 128, TextField.ANY);
	public Alert noSend = new Alert("Send Message Failed!", "", null, AlertType.INFO);
	public Alert yesSend = new Alert("Success", "Mail sent successfully", null, AlertType.INFO);
   
    
    
    public static Command BACK = new Command("Back", Command.BACK, 0);
    public static Command BACKTEXT = new Command("Back", Command.BACK, 1);
    public static Command SEND = new Command("Send", Command.SCREEN, 2);
    public static Command WRITETEXT = new Command("Write", Command.SCREEN, 2);

	public static String title_reply = "Reply Mail";
	public static String title_forw = "Forward Mail";

    private SmtpThread smtpThread;
    private StartMidlet midlet;
    private Message message;
   

    public ComposeScreen(StartMidlet _midlet) {
        super("Compose Mail");
        midlet = _midlet;
        smtpThread = new SmtpThread(Datas.localhost, this);
        	
        	append(rec_address);
        	append(cc);
        	append(subject);
        	//append(text);
       
        	addCommand(BACK);
        
        	addCommand(WRITETEXT);
        	setCommandListener(this);
        	
    }

	public ComposeScreen(StartMidlet _midlet, Message _message, String title, boolean isReply)
	{
		super(title);
		midlet = _midlet;
		smtpThread = new SmtpThread(Datas.localhost, this);
		message = _message;
		String sub;
		if (isReply)
		{
			sub = "RE:" + message.getHeaderValue("Subject", "No subject");
			rec_address.setString(message.getHeaderValue("From"));
			rec_address.setMaxSize(message.getHeaderValue("From").length());
		}
		else
		{
			sub = "FWD:" + message.getHeaderValue("Subject", "No subject");
		}
		
		subject.setString(sub);
		subject.setMaxSize(sub.length()+10);
		append(rec_address);
		append(cc);
		append(subject);
		addCommand(BACK);

		addCommand(WRITETEXT);
		setCommandListener(this);

	}
	
    /**
     * 
     * @param cmd
     * @param dsp
     */
     public void commandAction(Command cmd, Displayable dsp) {
     		if (cmd == WRITETEXT) {
     			if (text == null) 
     				midlet.display.setCurrent(getGuiText());
				
     			else
     				midlet.display.setCurrent(text);
     				
     		}
     		else if (cmd == SEND) {
     			//TODO: Mandare mail
				Message newMsg = new Message(Datas.address, rec_address.getString(), subject.getString());
				if (!cc.getString().equals(""))
				newMsg.setHeaderValue("Cc", cc.getString());
				newMsg.addBodyLine(text.getString()); //DA VERIFICARE!!
				//Envelope env = new Envelope(newMsg, true);
				smtpThread.start();
				smtpThread.sendMessage(newMsg);
				smtpThread.close();
     		}
     		else if (cmd == BACK) {
     			midlet.display.setCurrent(midlet.getGuiInboxScreen());
     		}
     		else if (cmd == BACKTEXT) {
     			midlet.display.setCurrent(this); //DA provare!!
     		}
     		
    }
     /**
      * get mail text
      * @return
      */
    public Displayable getGuiText() {
	String mess = "";
	int dim = 1024;
	if (message != null) {
		for (int j=0; j < message.getBodyLineCount(); j++)
			mess += message.getBodyLine(j); //se ci sono attach??Prendere solo la parte testo!!
		
	}

      	text = new TextBox("Mail",  mess, dim, TextField.ANY);
      	text.addCommand(SEND);
      	text.addCommand(BACKTEXT);
      	text.setCommandListener(this);
      	return text;
      	
      }
    /**
     * send failure
     * @param exc
     */
	public void getSendFailedGui(String exc)
	{
		noSend.setString(exc);
		noSend.setImage(GenericContents.displayImage("error"));
		midlet.display.setCurrent(noSend, this);
	}
	/**
	 * send success
	 *
	 */
	public void notifySendSuccess()
	{
		yesSend.setImage(GenericContents.displayImage("send"));
		midlet.display.setCurrent(yesSend, midlet.getGuiInboxScreen());
	}
        
        
    
    
}
