/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

package contents;

import java.util.Hashtable;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Spacer;
import java.io.InputStream;

/**
 *Class for generic contents 
 * 
 *@author Gabriele Bianchi
 */
public class GenericContents {

	public static Hashtable images;
	
	public static String help_text = "Check mails: connect to your inbox\n"
				  +"Settings: save your pop/smtp settings.\n";
	//Gui Commands
	//public static Command OK = new Command("Ok", Command.OK, 1);
	//public static Command BACK = new Command("Send", Command.OK, 1);
	//public static Command accept = new Command("Accept", Command.OK, 1);
	/*	
		public static Command exit = new Command("Exit", Command.EXIT, 0);
		public static Command disc = new Command("Options", Command.BACK, 1);
		public static Command deny = new Command("Deny", Command.BACK, 0);
		public static Command history = new Command("History", Command.ITEM, 2);*/
	
	//public static Command link = new Command("Activate link", Command.ITEM, 2);
	public static Command back = new Command("Back", Command.BACK, 0);
	public static Command stop = new Command("Stop", Command.STOP, 0);


	public static Command select = new Command("Select", Command.OK, 0);
	//other gui tools
	public static Alert help = new Alert("Help", help_text, null, AlertType.INFO);
	public static Alert saved = new Alert("Settings", "Data saved", null, AlertType.INFO);
	public static Alert noPhone = new Alert("Warning", "Your device doesn't support this feature!", null, AlertType.INFO);
	public static Alert alertRead = new Alert("Opening mail", "Please wait..", null, AlertType.INFO);
	public static Form wait_form = new Form("Connecting..");
	//public static Form start_form = new Form("Mobile Mail Checker");
	public static String errorCode = "Operation not executed!";
		
	public GenericContents() {
		images = new Hashtable(11);
		images.put("inbox","/inbox.png");
		images.put("start", "/mmc_logo2.png");
		images.put("mail","/mail.png");
		images.put("send","/mail_send.png");
		images.put("error","/error.png");
		images.put("wait","/mail_service.png");
		images.put("disconnected","/disconnected.png");
		images.put("attach","/attach.png");
		images.put("save", "/file_pull.png");
		images.put("time", "/clock.png");
		help.setTimeout(9000);
		

	}
	/**
	 *
	 *@param name
         *@return String
	 */
	public static String getImage(String name) {
		return (String)images.get(name);
	
	}
	/**
	 * Get Image object
	 *@param name
         *@return Image
	 */
	public static Image displayImage(String name) {
		Image image;
		try {
			image = Image.createImage(getImage(name));
		}catch (java.io.IOException e) {
			return null;
		}
		return image;
	
	}
    /**
	 * Get Image from stream
	 *@param name
         *@return Image
	 */
	public static Image displayImage(InputStream stream) {
		Image image;
		try {
			image = Image.createImage(stream);
		}catch (java.io.IOException e) {
			return null;
		}
		return image;
	
	}
}
