/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package contents;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import util.Datas;
import mmc.StartMidlet;
import threads.InboxThread;
import java.util.Vector;

/**
 * Inbox screen
 * @author Gabriele Bianchi
 *
 */
public class MainScreen extends Form {


    public ChoiceGroup mails = new ChoiceGroup("Messages:", Choice.EXCLUSIVE);

    
	public static Command READ = new Command("Read", Command.SCREEN, 1);
    public static Command BACK = new Command("Back", Command.EXIT, 2);
    public static Command WRITE = new Command("Compose", Command.SCREEN, 3);
    public static Command REFRESH = new Command("Refresh", Command.SCREEN, 4);

    private InboxThread inboxThread;
    public Vector messages;

    public MainScreen(StartMidlet midlet) {
        super("Inbox");
        
        inboxThread = midlet.inboxThread;
		
        try {
        	messages = inboxThread.getMessageList();
			
        }catch (Exception e) {midlet.genericErrorConnection(e.getMessage());}
        	this.append(Datas.cont.displayImage("inbox"));
        if (messages.size() == 0) {
        		this.append(new StringItem("Inbox empty!", ""));
        		addCommand(BACK);
        		addCommand(WRITE);
        		addCommand(REFRESH);

        		setCommandListener(midlet);
        }
        else {
        	for (int i=0; i < messages.size(); i++) {
        			
        			mails.append((String)messages.elementAt(i), GenericContents.displayImage("mail"));
        			
        	}
        	append(mails);
        	addCommand(BACK);
        	addCommand(READ);
        	addCommand(WRITE);
        	addCommand(REFRESH);
        	setCommandListener(midlet);
        	
        }
        
        
    }
    
}