/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package contents;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.lang.Integer;
import util.Datas;
import mmc.StartMidlet;

/**
 * Represents the setup-screen for settings. 
 * @author Gabriele Bianchi
 *
 */
public class SetupScreen extends Form {

    public TextField address  = new TextField("Address:",  Datas.address, 128, TextField.EMAILADDR);
    public TextField hostname = new TextField("Local host:", Datas.localhost, 128, TextField.URL);
    public String[] names = {"POP3", "IMAP"};
    public TextField pop3Port = new TextField("Inbox Port :", String.valueOf(Datas.port), 4, TextField.ANY);
    public ChoiceGroup services = new ChoiceGroup("Inbox type:", Choice.EXCLUSIVE, names, null);
    public TextField pop3Host = new TextField("Inbox host:", Datas.pop3Host, 128, TextField.URL);
    public TextField pop3User = new TextField("Username :", Datas.pop3User, 128, TextField.ANY);
    public TextField pop3Pass = new TextField("Password:", Datas.password, 128, TextField.PASSWORD);
    public TextField smtpHost = new TextField("SMTP host:", Datas.smtpHost, 128, TextField.URL);
    public String[] options = {"Off", "On"};
    public ChoiceGroup smtpAuth = new ChoiceGroup("SMTP password:", Choice.EXCLUSIVE, options, null);
     public String[] ssloptions = {"Off", "On"};
    public ChoiceGroup pop3Ssl = new ChoiceGroup("Use SSL:", Choice.EXCLUSIVE, ssloptions, null);


    public static Command OK = new Command("Ok", Command.SCREEN, 1);
    public static Command BACK = new Command("Back", Command.EXIT, 2);

    

    public SetupScreen(StartMidlet midlet) {
        super("Settings");

        append(address);
        append(hostname);
		if (Datas.imap)
			services.setSelectedIndex(1, true);
        append(services);
        append(pop3Host);
        append(pop3User);
        append(pop3Pass);
        append(pop3Port);
        append(smtpHost);
		if (Datas.smtpAuth)
			smtpAuth.setSelectedIndex(1, true);
        append(smtpAuth);
		if (Datas.ssl)
			pop3Ssl.setSelectedIndex(1, true);
        append(pop3Ssl);
        


        addCommand(OK);
		addCommand(BACK);

        setCommandListener(midlet);
    }
 
    public String getAddress() {
        return address.getString();
    }
 
    public String getHostname() {
        return hostname.getString();
    }

    public boolean getImap() {
        return services.isSelected(1);
    }

    public String getPop3Host() {
        return pop3Host.getString();
    }

    public String getPop3User() {
        return pop3User.getString();
    }

    public String getPop3Pass() {
        return pop3Pass.getString();
    }
    public int getPop3Port() {
        return Integer.parseInt(pop3Port.getString());
    }
    
    public boolean getPop3Ssl() {
        return pop3Ssl.isSelected(1);
    }


    public String getSmtpHost() {
        return smtpHost.getString();
    }

    public boolean getSmtpAuth() {
        return smtpAuth.isSelected(1);
    }





}