/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
package contents;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import util.*;
import mmc.StartMidlet;
import threads.InboxThread;
import java.util.Timer;

/**
 * Represents the start-screen that shows options. 
 * @author Gabriele Bianchi
 *
 */
public class StartScreen extends Form implements ItemCommandListener, CommandListener
{

	private StringItem check = new StringItem("Check mails", " open your inbox", Item.HYPERLINK);
	private StringItem setts = new StringItem("Settings", " mail server settings", Item.HYPERLINK);
	private StringItem poll = new StringItem("Check automatically", " set the polling timer", Item.HYPERLINK);
	private StringItem help = new StringItem("Help", " can I help you?", Item.HYPERLINK);
	private StartMidlet midlet;
	private PollingTask task;
	private Timer timer;
	private Form polling;
	public String[] options = { "5 minutes", "10 minutes", "20 minutes" };
	public ChoiceGroup time = new ChoiceGroup("Rate:", Choice.EXCLUSIVE, options, null);
	


	public static Command EXIT = new Command("Exit", Command.EXIT, 0);
	public static Command OK = new Command("Ok", Command.OK, 1);
	// public static Command REFRESH = new Command("Refresh", Command.SCREEN, 4);


	public StartScreen(StartMidlet midlet)
	{
		super("Mobile Mail Checker");
		this.midlet = midlet;
	
		check.addCommand(OK); check.setItemCommandListener(this);
		setts.addCommand(OK); setts.setItemCommandListener(this);
		poll.addCommand(OK); poll.setItemCommandListener(this);
		help.addCommand(OK); help.setItemCommandListener(this);
		//ImageItem image = new ImageItem("", GenericContents.displayImage("start"),ImageItem.LAYOUT_CENTER, "start logo");
		append(GenericContents.displayImage("start"));
		append(check);
		append(setts);
		append(poll);
		append(help);
		

		addCommand(EXIT);

		setCommandListener(midlet);

	}

	/**
	* @param Command
	* @param Item
   */
	public void commandAction(Command cmd, Item i)
	{
		if (cmd == OK)
		{
			if (((StringItem)i).getLabel().equals("Check mails"))
			{
				if (Datas.connected)
				{
					midlet.display.setCurrent(midlet.getGuiInboxScreen());
				}
				else
				{
					if (Datas.imap)
					{
						midlet.inboxThread = new InboxThread(false, midlet);
					}
					else
					{
						midlet.inboxThread = new InboxThread(true, midlet);
					}
					if (GenericContents.wait_form.size() == 0)
						GenericContents.wait_form.append(GenericContents.displayImage("wait"));
					midlet.display.setCurrent(GenericContents.wait_form);
					midlet.inboxThread.start();
				}
			}
			else if (((StringItem)i).getLabel().equals("Settings"))
			{

				if (Datas.connected)
				{
					midlet.inboxThread.close();
					//Datas.connected = false;
					midlet.display.setCurrent(new Alert("Disconnecting..", "Back to the settings panel", GenericContents.displayImage("disconnected"), AlertType.INFO), midlet.getGuiParamScreen());
				}
				else
					midlet.display.setCurrent(midlet.getGuiParamScreen());
			}
			else if (((StringItem)i).getLabel().equals("Check automatically"))
			{
				midlet.display.setCurrent(getGuiPollingScreen());
			}
			else if (((StringItem)i).getLabel().equals("Help"))
			{
				midlet.display.setCurrent(GenericContents.help, this);
			}
			else midlet.display.setCurrent(this);
		}
	}

	/**
	* @param Command
	* @param Displayable
   */
	public void commandAction(Command cmd, Displayable dsp)
	{
		if (cmd == OK)
		{

			if (task != null)
			{
				timer.cancel();
				task.cancel();//blocca task precedente
			}
		
			task = new PollingTask(midlet);
			timer = new Timer();
			if (time.getSelectedIndex() == 0)
			{
				
				timer.schedule(task, 1000, 300000);
			}
			else if (time.getSelectedIndex() == 1)
			{
				timer.schedule(task, 1000, 600000);
			}
			else 
			{
				timer.schedule(task, 1000, 1200000);
			}
			midlet.display.setCurrent(new Alert("Success..", "Timer set", GenericContents.displayImage("time"), AlertType.INFO));
		}
		else
			midlet.display.setCurrent(this);
	}

	private Form getGuiPollingScreen() {
		if (polling == null)
		{
			polling = new Form("Set polling rate");
			polling.append(time);
			polling.addCommand(OK);
			polling.addCommand(EXIT);
			polling.setCommandListener(this);
		}
		return polling;
	}
}